//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfxgmail.com"

#property indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    DeepSkyBlue
#property indicator_width1    2
#property indicator_minimum  -5
#property indicator_maximum 105
#property indicator_level1   80
#property indicator_level2   20
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    T3Period              = 32;
extern int    T3Price               = PRICE_CLOSE;
extern double T3Hot                 = 0.618;
extern bool   T3Original            = false;
extern bool   UseMomentum           = true;
extern bool   UseCumulativeMomentum = true;
extern int    NormalizingPeriods    = 50;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double emas[][6];
double alpha;
double c1;
double c2;
double c3;
double c4;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);

   //
   //
   //
   //
   //
   
      double a  = T3Hot;
             c1 = -a*a*a;
             c2 = 3*a*a+3*a*a*a;
             c3 = -6*a*a-3*a-3*a*a*a;
             c4 = 1+3*a+a*a*a+3*a*a;

   //
   //
   //
   //
   //
               
      T3Period = MathMax(1,T3Period);
      if (T3Original)
           alpha = 2.0/(1.0 + T3Period);
      else alpha = 2.0/(2.0 + (T3Period-1.0)/2.0);
      IndicatorShortName("T3 oscillator ("+T3Period+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      buffer3[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),i);
      buffer2[i] = 0;
         if (UseMomentum)
            if (UseCumulativeMomentum)
                  for (int k = 0; k<T3Period; k++) buffer2[i] += (buffer3[i+k]-buffer3[i+T3Period+k]);
            else  buffer2[i] = (buffer3[i]-buffer3[i+T3Period]);
         else     buffer2[i] =  buffer3[i];

      //
      //
      //
      //
      //
      
      
         double hi = buffer2[ArrayMaximum(buffer2,NormalizingPeriods,i)];
         double lo = buffer2[ArrayMinimum(buffer2,NormalizingPeriods,i)];
         if (hi != lo)
               buffer1[i] = 100*(buffer2[i]-lo)/(hi-lo);
         else  buffer1[i] = 0.00;
   }         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price,int shift)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0] = price;
         emas[i][1] = price;
         emas[i][2] = price;
         emas[i][3] = price;
         emas[i][4] = price;
         emas[i][5] = price;
      }
   else
      {
         emas[i][0] = emas[i-1][0]+alpha*(price     -emas[i-1][0]);
         emas[i][1] = emas[i-1][1]+alpha*(emas[i][0]-emas[i-1][1]);
         emas[i][2] = emas[i-1][2]+alpha*(emas[i][1]-emas[i-1][2]);
         emas[i][3] = emas[i-1][3]+alpha*(emas[i][2]-emas[i-1][3]);
         emas[i][4] = emas[i-1][4]+alpha*(emas[i][3]-emas[i-1][4]);
         emas[i][5] = emas[i-1][5]+alpha*(emas[i][4]-emas[i-1][5]);
      }
   return(c1*emas[i][5] + c2*emas[i][4] + c3*emas[i][3] + c4*emas[i][2]);
}